import { ElementSymbol, Matrix } from './matrix';
import { Rectangle } from './rectangle';
export declare type Borders = {
    topWidth: number;
    rightWidth: number;
    bottomWidth: number;
    leftWidth: number;
    topSymbols: (ElementSymbol | null)[];
    rightSymbols: (ElementSymbol | null)[];
    bottomSymbols: (ElementSymbol | null)[];
    leftSymbols: (ElementSymbol | null)[];
    topRightSymbols: (ElementSymbol | null)[];
    bottomRightSymbols: (ElementSymbol | null)[];
    bottomLeftSymbols: (ElementSymbol | null)[];
    topLeftSymbols: (ElementSymbol | null)[];
};
export declare function clearTopSide(matrix: Matrix, width: number): Matrix;
export declare function clearBottomSide(matrix: Matrix, width: number): Matrix;
export declare function clearLeftSide(matrix: Matrix, width: number): Matrix;
export declare function clearRightSide(matrix: Matrix, width: number): Matrix;
export declare function drawTopSide(matrix: Matrix, borderWidth: number, symbols: (ElementSymbol | null)[], fromX: number, toX: number): Matrix;
export declare function drawBottomSide(matrix: Matrix, borderWidth: number, symbols: (ElementSymbol | null)[], fromX: number, toX: number): Matrix;
export declare function drawLeftSide(matrix: Matrix, borderWidth: number, symbols: (ElementSymbol | null)[], fromY: number, toY: number): Matrix;
export declare function drawRightSide(matrix: Matrix, borderWidth: number, symbols: (ElementSymbol | null)[], fromY: number, toY: number): Matrix;
export declare function drawCorner(matrix: Matrix, rectangle: Rectangle, symbols: (ElementSymbol | null)[]): Matrix;
export declare function validateMatrixWithBorders(matrix: Matrix, borders: Borders): boolean;
export declare function placeBorders(matrix: Matrix, borders: Borders): {
    matrix: Matrix;
    contentArea: Rectangle;
};
