import { Borders } from './border';
import { ElementBody, ElementSymbol, Matrix, SymbolRuler } from './matrix';
import { Rectangle } from './rectangle';
export declare type Box = {
    borders: Borders;
    children: Box[];
    content: string;
    matrix: Matrix;
    scroll?: {
        thumbElement?: ElementBody;
        trackElement?: ElementBody;
        y: number;
    };
    symbolRuler: SymbolRuler;
    x: number;
    y: number;
    zIndex: number;
};
export declare function defaultSymbolRuler(symbol: ElementSymbol): 0 | 1 | 2;
export declare function createBox(rectangleLike: {
    x?: Rectangle['x'];
    y?: Rectangle['y'];
    width: Rectangle['width'];
    height: Rectangle['height'];
}, options?: {
    defaultSymbol?: ElementSymbol | null;
}): Box;
export declare function renderBox(box: Box, options?: {
    backgroundSymbol?: ElementSymbol;
}): string;
