import * as utils from './utils';
import * as borderModule from './border';
import * as boxModule from './box';
import * as matrixModule from './matrix';
import * as rectangleModule from './rectangle';
export declare type BorderType = 'default';
export declare type Borders = borderModule.Borders;
export declare type Box = boxModule.Box;
export declare type Coordinate = utils.Coordinate;
export declare type ElementBody = matrixModule.ElementBody;
export declare type Rectangle = rectangleModule.Rectangle;
export declare type Size = utils.Size;
export declare type SymbolRuler = matrixModule.SymbolRuler;
export declare const createBox: typeof boxModule.createBox;
export declare const createElementBody: typeof matrixModule.createElementBody;
export declare const render: typeof boxModule.renderBox;
export declare function getWidth(box: Box): number;
export declare function getHeight(box: Box): number;
export declare function getMaxX(box: Box): number;
export declare function getMaxY(box: Box): number;
export declare function createBordersByType(borderType: BorderType): Borders;
