"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var boxModule = require("./box");
var matrixModule = require("./matrix");
exports.createBox = boxModule.createBox;
exports.createElementBody = matrixModule.createElementBody;
exports.render = boxModule.renderBox;
function getWidth(box) {
    return matrixModule.getWidth(box.matrix);
}
exports.getWidth = getWidth;
function getHeight(box) {
    return matrixModule.getHeight(box.matrix);
}
exports.getHeight = getHeight;
function getMaxX(box) {
    return matrixModule.getMaxX(box.matrix);
}
exports.getMaxX = getMaxX;
function getMaxY(box) {
    return matrixModule.getMaxY(box.matrix);
}
exports.getMaxY = getMaxY;
function createBordersByType(borderType) {
    switch (borderType) {
        case 'default':
            return {
                topWidth: 1,
                bottomWidth: 1,
                leftWidth: 1,
                rightWidth: 1,
                topSymbols: ['-'],
                bottomSymbols: ['-'],
                leftSymbols: ['|'],
                rightSymbols: ['|'],
                topLeftSymbols: ['+'],
                topRightSymbols: ['+'],
                bottomLeftSymbols: ['+'],
                bottomRightSymbols: ['+'],
            };
    }
}
exports.createBordersByType = createBordersByType;
