import { Coordinate, Size } from './utils';
export declare type Rectangle = {
    x: Coordinate['x'];
    y: Coordinate['y'];
    width: Size['width'];
    height: Size['height'];
};
export declare function rectangleToCoordinate(rectangle: Rectangle): Coordinate;
export declare function rectangleToSize(rectangle: Rectangle): Size;
export declare function moveRectangle(rectangle: Rectangle, coordinate: Coordinate): Rectangle & {
    y: number;
    x: number;
};
/**
 * Shrink a rectangle with margins
 */
export declare function shrinkRectangle(rectangle: Rectangle, margins?: {
    top?: number;
    bottom?: number;
    left?: number;
    right?: number;
}): Rectangle;
