"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function rectangleToCoordinate(rectangle) {
    return {
        x: rectangle.x,
        y: rectangle.y,
    };
}
exports.rectangleToCoordinate = rectangleToCoordinate;
function rectangleToSize(rectangle) {
    return {
        width: rectangle.width,
        height: rectangle.height,
    };
}
exports.rectangleToSize = rectangleToSize;
function moveRectangle(rectangle, coordinate) {
    return Object.assign({}, rectangle, {
        y: rectangle.y + coordinate.y,
        x: rectangle.x + coordinate.x,
    });
}
exports.moveRectangle = moveRectangle;
/**
 * Shrink a rectangle with margins
 */
function shrinkRectangle(rectangle, margins) {
    if (margins === void 0) { margins = {}; }
    var _a = Object.assign({}, {
        top: 0,
        bottom: 0,
        left: 0,
        right: 0,
    }, margins), top = _a.top, bottom = _a.bottom, left = _a.left, right = _a.right;
    if (top < 0 || bottom < 0 || left < 0 || right < 0) {
        throw new Error('Can not receive negative margins');
    }
    var y = rectangle.y + top;
    var height = rectangle.height - top - bottom;
    var x = rectangle.x + left;
    var width = rectangle.width - left - right;
    return { x: x, y: y, width: width, height: height };
}
exports.shrinkRectangle = shrinkRectangle;
